unit mravenec;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, DXClass, Menus, IniFiles,mraveniste;

const   MAX_X=785;
        MAX_Y=625;
        MIN_X=5;
        MIN_Y=5;

type
  TAnt = class
              xx,yy :real;
              delka,citac :byte;
              index: integer;
              smer : real;
              snimek : byte;
              pocetSnimku : byte;
              naklad :integer;
              uloha: byte;
              move_ant : byte;
              kam_x, kam_y : integer;
              constructor Init(kdo : integer);
              function What_I_See : integer;
              procedure Step;
              destructor done;
         end;

  TMravenec = class(TAnt)
              live : byte;   // jeho stadium zivota..
              inteligence : byte;
              energy : byte;

              constructor Init(kdo : integer);
              procedure Writelog;
              procedure Find_Ant_Hill;
              procedure Find_Wood;
              procedure Find_Egg;
              procedure Find_Well;
              procedure Zobraz;
              procedure Pohyb;
              procedure Go(x,y :integer);
              procedure New_Ant;
            end;


  TQueen_Ant = class(TAnt)
              counter_eggs : integer;
              constructor Init(kdo : integer);
              procedure Pohyb;
              procedure Zobraz;
           end;
  Type_Array_Ants = array of TMravenec;

  var  Data_Ants : Type_Array_Ants;
       Queen_Ant : TQueen_Ant;

implementation

uses fanim;

constructor TAnt.Init(kdo : integer);
var random_smer,px,py : integer;
begin
  index:=kdo;
  pocetSnimku := 3;
  random_smer:=random(360);
  smer:=Pi/180*random_smer;
  uloha:=random(4);    // bud nosic vajicek nebo vetvicek
  move_ant:=0;
  repeat
    randomize;
     px := random(23)+2;
     py := random(18)+2;
    until Ant_Hill.Data_Images[px,py]=0  ;
 // Ant_Hill.Data_Images[px,py]:=4;

  xx:=px*32;
  yy:=py*32;
  citac:=0;
  snimek:=random(3);
  delka:=random(20)+10;

end;

constructor Tmravenec.Init(kdo : integer);
begin
  inherited Init(kdo);
  naklad:=0;
  energy:=random(50)+50;
  inteligence:=5;
  live:=random(60)+40;

end;

procedure Tmravenec.New_Ant;
var random_smer : integer;
begin
  Ant_Hill.curr_num_ants_really := Ant_Hill.curr_num_ants_really +1;
  pocetSnimku := 3;
  random_smer:=random(360);
  smer:=Pi/180*random_smer;
  uloha:=random(5);    // bud nosic vajicek nebo vetvicek
  move_ant:=0;
  xx:=Ant_Hill.curr_pos_ant_hill_x;
  yy:=Ant_Hill.curr_pos_ant_hill_y;
  citac:=0;
  snimek:=random(3);
  naklad:=0;
  energy:=100;
  inteligence:=5;
  delka:=random(20)+10;
  live:=100;
end;

constructor TQueen_Ant.Init(kdo : integer);
var random_smer,px,py : integer;
begin
  inherited Init(kdo);
  naklad:=-1;
  delka:=random(20)+10;
  counter_eggs:=random(20)+5;
end;

function TAnt.What_I_See : integer;
var vzdalenost,i : integer;
    px,py,ox,oy,rx,ry : integer;
begin
with Ant_Hill do
begin
 What_I_See:=0;
 px:= round(xx + cos(smer)*16);         // co uvidi v nasledujicim kroku pred sebou
 py:= round(yy + sin(smer)*16);
 ox:= round(xx + cos(smer-Pi/4)*8);    // co uvidi v nasledujicim kroku na levo
 oy:= round(yy + sin(smer-Pi/4)*8);
 rx:= round(xx + cos(smer+Pi/4)*8);    // co uvidi v nasledujicim kroku na pravo
 ry:= round(yy + sin(smer+Pi/4)*8);

 if (Data_Images[(px div 32),(py div 32)] =3) or (Data_Images[(ox div 32),(oy div 32)]=3) or (Data_Images[(rx div 32),(ry div 32)]=3)
   then What_I_See:=3;     // vidi kamen


 if (Data_Images[(px div 32),(py div 32)]=2) or (Data_Images[(ox div 32),(oy div 32)]=2) or (Data_Images[(rx div 32),(ry div 32)]=2)
   then What_I_See:=2;     // vidi travu
 if ((abs(px-curr_pos_ant_hill_x))< (curr_size_ant_hill div 2)) and ((abs(py-curr_pos_ant_hill_y))< (curr_size_ant_hill div 2))
    then
     begin                 // mraveniste
      vzdalenost:=round(sqrt((px-curr_pos_ant_hill_x)*(px-curr_pos_ant_hill_x)+(py-curr_pos_ant_hill_y)*(py-curr_pos_ant_hill_y)));
      if vzdalenost<(curr_size_ant_hill div 2) then What_I_See:=1;
     end;
 if (naklad=0) and (uloha=0) then     // vidi vajicko a nema naklad a nosi vajicka
  for i:=0 to curr_num_eggs-1  do
   begin
    if Data_Egg[i].where=2 then
     begin
      if (px>=Data_Egg[i].x) and (px<=(Data_Egg[i].x +14))  and
        (py>=Data_Egg[i].y) and (py<=(Data_Egg[i].y +14))
       then begin
             What_I_See:=i+10;  //naklad:=What_I_See;
           end;
      if (ox>=Data_Egg[i].x) and (ox<=(Data_Egg[i].x +14))  and
        (oy>=Data_Egg[i].y) and (oy<=(Data_Egg[i].y +14))
       then begin
             What_I_See:=i+10;  //naklad:=What_I_See;
           end;
      if (rx>=Data_Egg[i].x) and (rx<=(Data_Egg[i].x +14))  and
        (ry>=Data_Egg[i].y) and (ry<=(Data_Egg[i].y +14))
       then begin
             What_I_See:=i+10;  //naklad:=What_I_See;
           end;

     end;
   end;

 if (naklad=0) and (uloha>0)  then     // vidi vetsicku a nema naklad  a nosi vetvicky
  for i:=0 to curr_num_woods-1 do
   begin
    if Data_Wood[i].where=2 then
     begin
      if (px>=Data_Wood[i].x) and (px<=(Data_Wood[i].x +14))  and
        (py>=Data_Wood[i].y) and (py<=(Data_Wood[i].y +14))
       then begin
             What_I_See:=i+100;
           end;
      if (ox>=Data_Wood[i].x) and (ox<=(Data_Wood[i].x +14))  and
        (oy>=Data_Wood[i].y) and (oy<=(Data_Wood[i].y +14))
       then begin
             What_I_See:=i+100;
           end;
      if (rx>=Data_Wood[i].x) and (rx<=(Data_Wood[i].x +14))  and
        (ry>=Data_Wood[i].y) and (ry<=(Data_Wood[i].y +14))
       then begin
             What_I_See:=i+100;
           end;

     end;
   end;

 if ((px>position_well_x) and (px<position_well_x+32) and (py>position_well_y) and (py<position_well_y+32)) or
    ((ox>position_well_x) and (ox<position_well_x+32) and (oy>position_well_y) and (oy<position_well_y+32)) or
    ((rx>position_well_x) and (rx<position_well_x+32) and (ry>position_well_y) and (ry<position_well_y+32)) then
      begin
        What_I_See:=4;  //vidi studni
      end;
 if (move_ant=3) then
 if ((px>kam_x) and (px<kam_x+24) and (py>kam_y) and (py<kam_y+24)) or
    ((ox>kam_x) and (ox<kam_x+24) and (oy>kam_y) and (oy<kam_y+24)) or
    ((rx>kam_x) and (rx<kam_x+24) and (ry>kam_y) and (ry<kam_y+24)) then
      begin
        What_I_See:=5;  //vidi studni
      end;

 end;
end;

procedure TMravenec.Writelog;
var f:textfile;
begin
  assignfile(f,'log.txt');
  append(f);
  writeln(f,round(xx),'  ',round(yy),'  ',delka,'  ');
  closefile(f);
end;


procedure TAnt.Step;
var pom : real;
begin

 xx:= xx + cos(smer)*4;
 if xx>=MAX_X-1 then
   begin
    smer:=smer*(-1) + Pi;
    xx:= xx - 4;
   end;
 if xx<=MIN_X+1 then
   begin
    smer:=(smer-Pi)*(-1);
    xx:= xx + 4;
   end;
 yy:= yy + sin(smer)*4;
 if yy>=MAX_Y-1 then
   begin
    smer:=-smer;
    yy:= yy - 4;
   end;
 if yy<=MIN_Y+1 then
   begin
    smer:=-smer;
    yy:= yy + 4;
   end;
end;

procedure TMravenec.Find_Ant_Hill;     // najde uhel k mravenisti
var px, py,x,y : integer;
begin
with Ant_Hill do
 begin
 x:=round(xx);
 y:=round(yy);
 px:=x-curr_pos_ant_hill_x;
 py:=y-curr_pos_ant_hill_y;
 if px>0 then smer:=arctan(py/px)+Pi
  else smer:=arctan(py/px);
 end;
end;

procedure TMravenec.Find_Well;     // najde uhel ke studni
var px, py,x,y : integer;
begin
with Ant_Hill do
 begin
 x:=round(xx);
 y:=round(yy);
 px:=x-Ant_Hill.position_well_x;
 py:=y-Ant_Hill.position_well_y;
 if px>0 then smer:=arctan(py/px)+Pi
  else smer:=arctan(py/px);
 end;
end;

procedure TMravenec.Find_Wood;     // najde uhel k vetvicce
var px, py,x,y,i : integer;
    best_distance : integer;  // zatim nejlepsi vzdalenost od vetvicky
    best_dis_index : integer; // indexs nejlepsi vetvicky
    vzdalenost : integer;     // prave pocitana vzdalenost
begin
if (live<90) then
begin
 with Ant_Hill do begin
 x:=round(xx);
 y:=round(yy);
 best_distance:=800;
 for i:=0 to curr_num_woods-1 do
  if Data_Wood[i].where=2 then
   begin
     vzdalenost:=round(sqrt((x-Data_Wood[i].x)*(x-Data_Wood[i].x)+(y-Data_Wood[i].y)*(y-Data_Wood[i].y)));
     if (vzdalenost<best_distance) and (vzdalenost<(inteligence*20)) then
       begin
         best_distance:=vzdalenost;
         best_dis_index:=i;
       end;
   end;
 if best_distance<800 then
   begin
    px:=x-Data_Wood[best_dis_index].x;
    py:=y-Data_Wood[best_dis_index].y;
    if px>0 then smer:=arctan(py/px)+Pi
       else smer:=arctan(py/px);
    delka:=best_distance div 32;
   end;
 end;
end;
end;

procedure TMravenec.Find_Egg;     // najde uhel k vetvicce
var px, py,x,y,i : integer;
    best_distance : integer;  // zatim nejlepsi vzdalenost od vetvicky
    best_dis_index : integer; // indexs nejlepsi vetvicky
    vzdalenost : integer;     // prave pocitana vzdalenost
begin
if (live<90) then
begin
 with Ant_Hill do begin
 x:=round(xx);
 y:=round(yy);
 best_distance:=800;
 for i:=0 to curr_num_eggs-1 do
  if Data_Egg[i].where=2 then
   begin
     vzdalenost:=round(sqrt((x-Data_Egg[i].x)*(x-Data_Egg[i].x)+(y-Data_Egg[i].y)*(y-Data_Egg[i].y)));
     if (vzdalenost<best_distance) and (vzdalenost<(inteligence*20)) then
       begin
         best_distance:=vzdalenost;
         best_dis_index:=i;
       end;
   end;
 if best_distance<800 then
   begin
    px:=x-Data_Egg[best_dis_index].x;
    py:=y-Data_Egg[best_dis_index].y;
    if px>0 then smer:=arctan(py/px)+Pi
       else smer:=arctan(py/px);
    delka:=best_distance div 32;
   end;
 end;
end;
end;

procedure TMravenec.Zobraz;
var x,y,i,vzdalenost : integer;
    angle_deg : integer;  // uhel ve stupnich
    angle_dx : integer; // uhel pro dx pri natoceni obrazku
    px,howmany : integer; // pro vypocet live a enegry

   // best_distance:integer;
begin
 with Ant_Hill do
 begin
 x:=round(xx);
 y:=round(yy);
 if MravenisteForm.WoodScanning1.Checked then
  if (naklad=0) and (uloha>0) then
  begin
   for i:=0 to curr_num_woods-1 do
    if Data_Wood[i].where=2 then
      begin
        vzdalenost:=round(sqrt((x-Data_Wood[i].x)*(x-Data_Wood[i].x)+(y-Data_Wood[i].y)*(y-Data_Wood[i].y)));
        if (vzdalenost<(inteligence*20)) then
          begin
           MravenisteForm.DXDraw1.Surface.Canvas.Pen.Color:=clGreen;
           MravenisteForm.DXDraw1.Surface.Canvas.Pen.Width:=1;
           MravenisteForm.DXDraw1.Surface.Canvas.MoveTo(x,y);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Wood[i].x,Data_Wood[i].y);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Wood[i].x+14,Data_Wood[i].y);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Wood[i].x+14,Data_Wood[i].y+14);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Wood[i].x,Data_Wood[i].y+14);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Wood[i].x,Data_Wood[i].y);
           MravenisteForm.DXDraw1.Surface.Canvas.Release;
         end;
     end;
    end
   else if (naklad=0) and (uloha=0) then
   begin
   for i:=0 to curr_num_eggs-1 do
    if Data_Egg[i].where=2 then
      begin
        vzdalenost:=round(sqrt((x-Data_Egg[i].x)*(x-Data_Egg[i].x)+(y-Data_Egg[i].y)*(y-Data_Egg[i].y)));
        if (vzdalenost<(inteligence*20)) then
          begin
           MravenisteForm.DXDraw1.Surface.Canvas.Pen.Color:=clWhite;
           MravenisteForm.DXDraw1.Surface.Canvas.Pen.Width:=1;
           MravenisteForm.DXDraw1.Surface.Canvas.MoveTo(x,y);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Egg[i].x+5,Data_Egg[i].y+5);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Egg[i].x+21,Data_Egg[i].y+5);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Egg[i].x+21,Data_Egg[i].y+21);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Egg[i].x+5,Data_Egg[i].y+21);
           MravenisteForm.DXDraw1.Surface.Canvas.LineTo(Data_Egg[i].x+5,Data_Egg[i].y+5);
           MravenisteForm.DXDraw1.Surface.Canvas.Release;
         end;
     end;
    end;

 angle_deg:=round(smer/Pi*180);
 if ((angle_deg=0) or (angle_deg=90
 ) or (angle_deg=180) or (angle_deg=270) or (angle_deg=360)) then
  inc(angle_deg);
 angle_dx :=round(angle_deg*255/360);
 if (move_ant=0) or (move_ant=5) or (move_ant=3) then snimek:=(snimek+1) mod PocetSnimku;
 if (move_ant=2) or (move_ant=5) or (move_ant=3) then begin
   px := x - 30;
   MravenisteForm.DXDraw1.Surface.Canvas.MoveTo(x,y);
   MravenisteForm.DXDraw1.Surface.Canvas.Pen.Color:=clSilver;
   MravenisteForm.DXDraw1.Surface.Canvas.Ellipse(x-15, y-15, x+17, y+17);
   MravenisteForm.DXDraw1.Surface.Canvas.Brush.Color:=clSilver;
   MravenisteForm.DXDraw1.Surface.Canvas.Pen.Color:=clBlue;
   MravenisteForm.DXDraw1.Surface.Canvas.Pen.Width:=2;
   MravenisteForm.DXDraw1.Surface.Canvas.MoveTo(px,y-24);
   howmany:=round(75/100*energy);
   MravenisteForm.DXDraw1.Surface.Canvas.LineTo(px+howmany,y-24);
   MravenisteForm.DXDraw1.Surface.Canvas.Pen.Color:=clRed;
   MravenisteForm.DXDraw1.Surface.Canvas.MoveTo(px,y-19);
   howmany:=round(75/100*live);
   MravenisteForm.DXDraw1.Surface.Canvas.LineTo(px+howmany,y-19);
   if uloha=0 then MravenisteForm.DXDraw1.Surface.Canvas.TextOut(x-30,y-40,' Egg Carrier ')
     else MravenisteForm.DXDraw1.Surface.Canvas.TextOut(x-30,y-40,' Wood Carrier ');
   MravenisteForm.DXDraw1.Surface.Canvas.Release;
 end;
 if (live>90) then MravenisteForm.DXImageList1.Items[13].DrawRotate(MravenisteForm.DXDraw1.Surface,x,y,16,16,snimek,0.5,0.5,angle_dx)
   else 
 if naklad=0 then
    MravenisteForm.DXImageList1.Items[1].DrawRotate(MravenisteForm.DXDraw1.Surface,x,y,24,24,snimek,0.5,0.5,angle_dx)
   else if (naklad>=10) and (naklad<100) then
       MravenisteForm.DXImageList1.Items[12].DrawRotate(MravenisteForm.DXDraw1.Surface,x,y,24,24,snimek,0.5,0.5,angle_dx)
     else if (naklad>100) then
        MravenisteForm.DXImageList1.Items[2].DrawRotate(MravenisteForm.DXDraw1.Surface,x,y,24,24,snimek,0.5,0.5,angle_dx)
 end;
end;



procedure TMravenec.Pohyb;
var x,y,distance,i,nearest,pom,Ant_See : integer;
    random_angle : integer;
begin
if (move_ant=0) or (move_ant=5) or (move_ant=3) then
begin
 inc(citac);
 if ((citac mod 16)=0) then if live>0 then live:=live-1;
 if naklad>0 then begin
     if ((citac mod 4)=0) then energy:=energy-1;
     end
   else  if ((citac mod 8)=0) then energy:=energy-1;
 if (energy=0) then live:=0;
 if live=0 then Ant_Hill.curr_num_ants_really:= Ant_Hill.curr_num_ants_really -1;
 Application.ProcessMessages;
 Ant_See := What_I_See;
 if (Ant_See=1) then
    begin     // vidi mraveniste
     if (naklad>0) then
        begin
         Ant_Hill.Put_Wood_Into_Hill(naklad,Ant_Hill.curr_size_ant_hill);
         naklad:=0;
         Smer:=Smer+Pi/2;
         Step;
        end
        else Step;
    end
 else if (Ant_See=2) then
    begin
      Step;
    end
 else if (Ant_See=3) then    // kamen
    begin
     repeat
      random_angle:=random(360);
     until random_angle<>0;
      smer:=Pi/180*random_angle;
      delka:=random(20)+20;
      citac:=0;
      Smer:=Smer+Pi;
      Step;
    end
 else if (Ant_See=4) then  // studnu
    begin
      if (energy<100) then energy:=energy+5
      else begin
       repeat
        random_angle:=random(360);
       until random_angle<>0;
        smer:=Pi/180*random_angle;
        delka:=50;
        citac:=0;
       // Smer:=Smer+Pi;
        Step;
      end;
    end
 else if (Ant_See=5) then    // misto, kam ma jit
    begin
      move_ant:=2;
    end
 else if (Ant_See=0) then   // nic
  begin

 randomize;
 x:=round(xx);
 y:=round(yy);
 if (move_ant=3) then Go(kam_x,kam_y)
 else
 if ((citac mod inteligence)=0) or (citac>=delka) then
   begin
    distance:=800;
    nearest:=-1;

    if naklad>0 then
      begin
         Find_Ant_Hill;
      end
      else if (energy>50) then begin
        if (uloha=0) then Find_Egg
           else Find_Wood;
        end
        else Find_Well;
   if citac>=delka then
     begin
     if naklad=0 then
       begin
        delka:=random(20)+20;
        citac:=0;
        if (energy>50) then begin
           if (uloha=0) then Find_Egg
              else Find_Wood;
          end
          else Find_Well;
       end
       else
        begin
         Find_Ant_Hill;
        end;
     end;
   end;
  Step;

 end
  else if (Ant_See>=10) and (Ant_See<100) then
 begin// vidi vajicko
   if (naklad=0) and (energy>50) and (live<90) then
     begin
       naklad:=Ant_See;
       Ant_Hill.Data_Egg[Ant_See-10].where:=4;  // mravenec nese vajicko a to neni nevykresluje
       Find_Ant_Hill;
     end
     else if (naklad=0) then  // malo energie pro noseni vetvisek
        begin

        end;
   Step;
 end       

 else if (Ant_See>=100) then
 begin// vidi vetvicku
   if (naklad=0) and (energy>50) and (live<90) then
     begin
       naklad:=Ant_See;
       Ant_Hill.Data_Wood[naklad-100].where:=4;  // mravenec nese vetsicku a ta neni nevykresluje
       Ant_Hill.curr_num_carried_woods := Ant_Hill.curr_num_carried_woods+1;
       Ant_Hill.curr_num_woods_really := Ant_Hill.curr_num_woods_really -1;
       Find_Ant_Hill;
     end;
   Step;
 end;
end;

 Zobraz;

 end;

procedure TQueen_Ant.Pohyb;
var x,y,distance,i,nearest,pom : integer;
    random_angle : integer;
begin
 inc(citac);
 counter_eggs:=counter_eggs-1;
 Application.ProcessMessages;
 if  What_I_See<>1   then begin
     if (counter_eggs=0) then begin
       Ant_Hill.Add_Eggs(round(xx),round(yy));
       counter_eggs:=random(30)+40;
      end;
    end;
 case What_I_See of
 1: begin     // narazi mraveniste
     Smer:=Smer+Pi/2;
    end;
 2: begin     // narazi travicku
      Step;
    end;
 3: begin     // narazi kaminek
     repeat
      random_angle:=random(360);
     until random_angle<>0;
      smer:=Pi/180*random_angle;
      delka:=random(20)+10;
      citac:=0;
      Smer:=Smer+Pi;
      Step;
    end;
 4: begin     // narazi na studnu
     repeat
      random_angle:=random(360);
     until random_angle<>0;
      smer:=Pi/180*random_angle;
      delka:=random(20)+10;
      citac:=0;
      Smer:=Smer+Pi;
      Step;
    end;
 0: begin    //
     Step;
    end;


 else // vidi vetvicku
   Step;

end; // case

Zobraz;

end;

procedure TQueen_Ant.Zobraz;
var x,y : integer;
    angle_deg : integer;  // uhel ve stupnich
    angle_dx : integer; // uhel pro dx pri natoceni obrazku
   // best_distance:integer;
begin
 with Ant_Hill do
 begin
 x:=round(xx);
 y:=round(yy);
 angle_deg:=round(smer/Pi*180);
 angle_dx :=round(angle_deg*255/360);
 snimek:=(snimek+1) mod PocetSnimku;
 MravenisteForm.DXImageList1.Items[9].DrawRotate(MravenisteForm.DXDraw1.Surface,x,y,33,32,snimek,0.5,0.5,angle_dx)
 end;
end;

procedure TMravenec.Go(x,y :integer);
var px, py,mx,my,vzdalenost : integer;
begin
// if (move_ant=2) then
with Ant_Hill do
 begin
 kam_x:=x;
 kam_y:=y;
 mx:=round(xx);
 my:=round(yy);
 px:=mx-x;
 py:=my-y;
 if px>0 then smer:=arctan(py/px)+Pi
  else smer:=arctan(py/px);
 end;
 //vzdalenost:=round(sqrt((mx-x)*(mx-x)+(my-y)*(my-y)));
 move_ant:=3;
end;


destructor TAnt.done;
begin
end;

end.
